\documentclass[a4paper,notitlepage,oneside,]{article}
\usepackage[a4paper,margin=2.54cm]{geometry}
\usepackage[T1]{fontenc}
\usepackage[sfdefault,scaled=.85]{FiraSans}
\usepackage{newtxsf}
\usepackage{framed}

%
\usepackage{hyperref}
\usepackage[acronym,toc]{glossaries}
\usepackage{parskip}
\usepackage{graphicx}
\usepackage{tabularx}
\usepackage{float}
\usepackage{enumitem}
\usepackage{fancyhdr}
\begin{document}
\frenchspacing
\pagestyle{fancyplain}
\renewcommand{\footrulewidth}{0.4pt}
\fancyhf{}
\fancyhf[HLE,HLO]{Experiment 1a - Setup an IGP(OSPF)}
\fancyhf[HRE,HRO,FRE,FRO]{\thepage}
\fancyhf[FLE,FLO]{DE-CIX Academy}
\fancyhf[FCE,FCO]{BGP for networks who peer}
\title{Experiment 1a - Setup an IGP (OSPF)}
\date{Version 1.1}
\author{\href{mailto:academy@decix.net}{DE-CIX Academy}}
\maketitle
\section{Purpose}
An IGP (Interior Gateway Protocol) distributes the interface IP addresses within an Autonomous System. This is needed so iBGP can connect.

\section{Network Setup}
\begin{figure}[H]
  \centering
  \includegraphics[width=\linewidth,page=1]{img/01-ibgp-drawings.pdf}
  \caption{Network Setup}
  \label{fig:networksetup}
\end{figure}
Figure \ref{fig:networksetup} shows the network topology for this experiment. All devices are connected in a ring like structure, each device has two neighbors.


\section{Slides}
%----------------------------------------------------------------
\clearpage
\begin{samepage}
\subsection*{\Huge Setup OSPF}
\LARGE
\begin{itemize}
  \item OSPF is configured on top of ipv4
  \item So you configure it on \emph{networks}, not on interfaces
  \item for each connected network you want to run it on.
  \item OSPF has a concept of \emph{areas} - for our simple setup we only use \emph{Area 0} (also called the backbone-area).
\end{itemize}
\vspace{1cm}

\begin{framed}
\begin{verbatim}
show interface brief

conf term

router ospf
  network 172.16.1.X/32 area 0
  network 172.16.1XX.0/29 area 0
  network 172.16.1YY.0/29 area 0
\end{verbatim}
\end{framed}

Parameters here are:
\begin{itemize}
  \item \textbf{XX} = your router ID (like 01, 02, \ldots)
\end{itemize}

Show commands:
\begin{itemize}
  \item \textbf{show ip route connected}\\
    to list your interface networks
  \item \textbf{show ip route ospf}
  \item \textbf{show ip ospf}
  \item \textbf{show ip ospf interface}
  \item \textbf{show ip ospf neighbor}
  \item \textbf{show ip route}
\end{itemize}
\end{samepage}
%----------------------------------------------------------------


\section{Your Device}
Please now connect to your device and check your IP adresses. Fill out the following table. The commands you need are \emph{show running} and \emph{show interface}:

\begin{tabular}{|r|p{3.5cm}|p{4cm}|p{4cm}|}
  \hline
   & \textbf{Router Name}& \textbf{Interface Name} & \textbf{IP Address} \\
  \hline
  Loopback: &  & \emph{dummy0} &  \\[0.5cm]
  \hline
  Interface to the left: & &  &  \\[0.5cm]
  \hline
  Interface to the right: & & & \\[0.5cm]
  \hline
\end{tabular}

\section{Setup OSPF}
\subsection{To set up OSPF you need to:}
\begin{itemize}
  \item Start the OSPF process
  \item Add networks where OSPF should run to the process
\end{itemize}

\subsection{The commands you need are:}
\begin{description}
  \item[show ip route ospf] shows you all prefixes routed within OSPF
  \item[show ip ospf] gives you information about the OSPF process
  \item[show ip ospf interface] shows details about each interface where OSPF is running
  \item[show ip ospf neighbor] shows disovered neighbor routers which run OSPF
\end{description}

\subsection{To configure OSPF in config mode you need:}
\begin{description}
  \item[router ospf] starts the OSPF process
  \item[network <a.b.c.d/mask> area <N>] enables OSPF on the given network with area \emph{N} (use area 0, the backbone area). You need one network statement for each network you want to run OSPF on including the dummy/loopback interface.
\end{description}

\subsection{Tasks:}
\begin{itemize}
  \item Enable OSPF on the right, left, and dummy interface
  \item Check the routing table after all routers have OSPF enabled. For this, do a \emph{show ip route ospf} and take note which loopback addresses are routed throuhg your left and which through your right interface
  \item Do a \emph{ping} to some of the other loopback addresses.
  \item Do a \emph{traceroute} to the other loopback addresses and take note which way the packets go
  \item Shut down one of your interfaces (command \emph{shutdown} in interface context in config mode), do the same traceroutes again. Has anything changed?
  \item Unshut (command: \emph{no shutdown}) the same interface and try again.
  \item Do all a \emph{show ip route ospf}, the one of the participants shuts down one interface. Do all the \emph{show ip route ospf} again and note what has changed.
\end{itemize}

\begin{minipage}{\textwidth}
\section{Solution}
\subsection{Solution for FRRouting}
\begin{verbatim}
  router ospf
    network 172.16.1.X/32 area 0
    network 172.16.1XX.0/29 area 0
    network 172.16.1YY.0/29 area 0
\end{verbatim}

Where:
\begin{itemize}
  \item \emph{XX} is your router (like 01, 02, \ldots)
  \item \emph{YY} is your neighbor on the left
\end{itemize}
\end{minipage}
\begin{minipage}{\textwidth}
\subsection{Solution for Juniper}
\begin{verbatim}
protocols {
  ospf {
        area 0.0.0.0 {
            interface em0.0;
            interface em1.0;
            interface lo0.0;
        }
    }
}
\end{verbatim}
\end{minipage}
\begin{minipage}{\textwidth}
\subsection{Solution for Mikrotik}
\begin{verbatim}
 
\end{verbatim}
\end{minipage}
  

\end{document}
